﻿/*
Deployment script for ContinuousIntegrationINT

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "ContinuousIntegrationINT"
:setvar DefaultFilePrefix "ContinuousIntegrationINT"
:setvar DefaultDataPath "C:\Program Files\Microsoft SQL Server\MSSQL12.MSSQLSERVER\MSSQL\DATA\"
:setvar DefaultLogPath "C:\Program Files\Microsoft SQL Server\MSSQL12.MSSQLSERVER\MSSQL\DATA\"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
USE [$(DatabaseName)];


GO
/*
The column [dbo].[Customer].[RankingID] is being dropped, data loss could occur.
*/

IF EXISTS (select top 1 1 from [dbo].[Customer])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
PRINT N'Dropping [dbo].[FK_Customer_customerRanking]...';


GO
ALTER TABLE [dbo].[Customer] DROP CONSTRAINT [FK_Customer_customerRanking];


GO
PRINT N'Altering [dbo].[Customer]...';


GO
ALTER TABLE [dbo].[Customer] DROP COLUMN [RankingID];


GO
PRINT N'Altering [dbo].[fnGetCustomer]...';


GO
/****** Script for SelectTopNRows command from SSMS  ******/
ALTER FUNCTION fnGetCustomer
(	
	-- Add the parameters for the function here
	@CustomerID bigint
)
RETURNS TABLE 
AS
RETURN 
(
	-- Add the SELECT statement with parameter references here
SELECT
      [FirstName]
      ,[LastName]
      ,[CustomerRanking]
  FROM [dbo].[Customer]
  where CustomerID = @CustomerID
)
GO
PRINT N'Refreshing [dbo].[vwAllCustomers]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[vwAllCustomers]';


GO
PRINT N'Refreshing [dbo].[vwCustomerOrderSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[vwCustomerOrderSummary]';


GO
PRINT N'Refreshing [dbo].[uspDeleteCustomer]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[uspDeleteCustomer]';


GO
PRINT N'Refreshing [dbo].[uspSelectCustomer]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[uspSelectCustomer]';


GO
PRINT N'Update complete.';


GO
