﻿/*
Deployment script for ContinuousIntegration

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "ContinuousIntegration"
:setvar DefaultFilePrefix "ContinuousIntegration"
:setvar DefaultDataPath "C:\Users\rba\AppData\Local\Microsoft\VisualStudio\SSDT\ContinuousIntegration"
:setvar DefaultLogPath "C:\Users\rba\AppData\Local\Microsoft\VisualStudio\SSDT\ContinuousIntegration"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
USE [$(DatabaseName)];


GO
PRINT N'Dropping [dbo].[FK_Customer_customerRanking]...';


GO
ALTER TABLE [dbo].[Customer] DROP CONSTRAINT [FK_Customer_customerRanking];


GO
PRINT N'Dropping [dbo].[PK_Deployment]...';


GO
ALTER TABLE [dbo].[Deployment] DROP CONSTRAINT [PK_Deployment];


GO
PRINT N'Altering [dbo].[Deployment]...';


GO
ALTER TABLE [dbo].[Deployment]
    ADD [DeployedBy] NVARCHAR (50) DEFAULT CURRENT_USER NOT NULL;


GO
PRINT N'Starting rebuilding table [dbo].[CustomerRanking]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_CustomerRanking] (
    [Id]          INT         NOT NULL,
    [Name]        NCHAR (32)  NULL,
    [Description] NCHAR (100) NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_CustomerRanking] PRIMARY KEY CLUSTERED ([Id] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[CustomerRanking])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_CustomerRanking] ([Id], [Name], [Description])
        SELECT   [Id],
                 [Name],
                 [Description]
        FROM     [dbo].[CustomerRanking]
        ORDER BY [Id] ASC;
    END

DROP TABLE [dbo].[CustomerRanking];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_CustomerRanking]', N'CustomerRanking';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_CustomerRanking]', N'PK_CustomerRanking', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creating [dbo].[FK_Customer_ToTable]...';


GO
ALTER TABLE [dbo].[Customer] WITH NOCHECK
    ADD CONSTRAINT [FK_Customer_ToTable] FOREIGN KEY ([RankingID]) REFERENCES [dbo].[CustomerRanking] ([Id]);


GO
PRINT N'Altering [dbo].[fnGetCustomer]...';


GO
/****** Script for SelectTopNRows command from SSMS  ******/
ALTER FUNCTION fnGetCustomer
(	
	-- Add the parameters for the function here
	@CustomerID bigint
)
RETURNS TABLE 
AS
RETURN 
(
	-- Add the SELECT statement with parameter references here
SELECT
      [FirstName]
      ,[LastName]
      ,[CustomerRanking]
  FROM [dbo].[Customer]
  where CustomerID = @CustomerID
)
GO
/*
Post-Deployment Script Template							
--------------------------------------------------------------------------------------
 This file contains SQL statements that will be appended to the build script.		
 Use SQLCMD syntax to include a file in the post-deployment script.			
 Example:      :r .\myfile.sql								
 Use SQLCMD syntax to reference a variable in the post-deployment script.		
 Example:      :setvar TableName MyTable							
               SELECT * FROM [$(TableName)]					
--------------------------------------------------------------------------------------
*/
IF (select count(*) from CustomerRanking) = 0
begin
INSERT INTO [dbo].[CustomerRanking] ([Id], [Name], [Description]) VALUES (1, N'Inactive                        ', N'No orders                                                                                           ')
INSERT INTO [dbo].[CustomerRanking] ([Id], [Name], [Description]) VALUES (2, N'Bronze                          ', N'Orders under $100                                                                                   ')
INSERT INTO [dbo].[CustomerRanking] ([Id], [Name], [Description]) VALUES (3, N'Silver                          ', N'Orders $100 to $999                                                                                 ')
INSERT INTO [dbo].[CustomerRanking] ([Id], [Name], [Description]) VALUES (4, N'Gold                            ', N'Orders $1,000 to $9,999                                                                             ')
INSERT INTO [dbo].[CustomerRanking] ([Id], [Name], [Description]) VALUES (5, N'Platinum                        ', N'Orders $10,000 and more                                                                             ')

end

insert into Deployment (DeploymentDate) values (getdate())
GO

GO
PRINT N'Checking existing data against newly created constraints';


GO
USE [$(DatabaseName)];


GO
ALTER TABLE [dbo].[Customer] WITH CHECK CHECK CONSTRAINT [FK_Customer_ToTable];


GO
PRINT N'Update complete.';


GO
